// dne 3.6.2000 naprogramoval soutezici 47

unit M47Hlavni;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls, ExtCtrls, M47About;

type
  THlavni = class(TForm)
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Otevt1: TMenuItem;
    N1: TMenuItem;
    Konec1: TMenuItem;
    Kontrola1: TMenuItem;
    Kontroluj1: TMenuItem;
    DialogOtevrit: TOpenDialog;
    ZdrojText: TRichEdit;
    VystupText: TRichEdit;
    Uloit1: TMenuItem;
    Uloitvstup1: TMenuItem;
    DialogUlozit: TSaveDialog;
    Splitter1: TSplitter;
    StatusBar1: TStatusBar;
    Oaplikaci1: TMenuItem;
    procedure Otevt1Click(Sender: TObject);
    procedure Uloit1Click(Sender: TObject);
    procedure Uloitvstup1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Kontroluj1Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Oaplikaci1Click(Sender: TObject);
  private
    Ulozeno:Boolean;
    SlovnikSoub:TextFile;
    procedure NactiSlovnik;
    procedure ZavriSlovnik;
    function PrefiltrujSlovo(VstupSlovo:string):string;
    function OcistiSlovo(VstupSlovo:string):string;
    function JeVeSlovniku(VstupSlovo:string):Boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Hlavni: THlavni;

implementation

{$R *.DFM}

procedure THlavni.Otevt1Click(Sender: TObject); //graf. rozhrani: nahraje vstupni soubor
begin
  if DialogOtevrit.Execute then ZdrojText.Lines.LoadFromFile(DialogOtevrit.FileName);
  Uloit1.Enabled:=True;
end;

procedure THlavni.Uloit1Click(Sender: TObject); //graf. rozhrani: ulozi vystupni soubor
begin
  ZdrojText.Lines.SaveToFile(DialogOtevrit.FileName);
end;

procedure THlavni.Uloitvstup1Click(Sender: TObject); //graf. rozhrani: ulozi vstupni soubor
begin
  if DialogUlozit.Execute then VystupText.Lines.SaveToFile(DialogUlozit.FileName);
  Ulozeno:=True;
end;

procedure THlavni.FormShow(Sender: TObject); //v pripade ze nejsou zadany alespon 2 parametry se spusi graf. rozhrani, v opacnem pripade program provede kontrolu, ulozi vysledky a zkonci
var ZdrojSoub,VysSoub:TextFile;
    Radek:string;
    KontPis:Integer;
    Slovo:string;
    PisVeSlov:Integer;
    NovyRadek:string;
begin
  Ulozeno:=True;
  if ParamCount>=2 then
  begin
    if FileExists(ParamStr(1)) then
    begin
      ShowMessage('Budu kontrolovat soubor '+ParamStr(1)+' a vsledky zapi do souboru '+ParamStr(2)+'. Tato operace me trvat dlouho.');
      AssignFile(ZdrojSoub,ParamStr(1));
      Reset(ZdrojSoub);
      AssignFile(VysSoub,ParamStr(2));
      ReWrite(VysSoub);
      while not EOF(ZdrojSoub) do
      begin
        ReadLn(ZdrojSoub,Radek);
        KontPis:=0;
        PisVeSlov:=1;
        Slovo:='';
        while KontPis<>Length(Radek)+1 do
        begin
          Inc(KontPis);
          if ((Radek[KontPis]<>' ')and(KontPis<>Length(Radek)+1)) then
          begin
            Slovo:=Slovo+' ';
            Slovo[PisVeSlov]:=Radek[KontPis];
            Inc(PisVeSlov);
          end
          else
          begin
            if JeVeSlovniku(OcistiSlovo(Slovo))=True then
            begin
              NovyRadek:=NovyRadek+Slovo+' ';
            end
            else NovyRadek:=NovyRadek+'#'+Slovo+' ';
            Slovo:='';
            PisVeSlov:=1;
          end;
        end;
        WriteLn(VysSoub,NovyRadek);
        NovyRadek:='';
      end;
      CloseFile(ZdrojSoub);
      CloseFile(VysSoub);
    end
    else ShowMessage('Vstupn soubor neexistuje!');
    ShowMessage('Program spn zkonil.');
    Close;
  end;
end;

function THlavni.PrefiltrujSlovo(VstupSlovo:string):string;  //odstrani cast za lomitkem u slov ze slovniku
var PridZnak:Boolean;
    CisloZnaku:Integer;
begin
  PridZnak:=True;
  Result:='';
  CisloZnaku:=0;
  while PridZnak do
  begin
    Inc(CisloZnaku);
    if (VstupSlovo[CisloZnaku]<>'/')and(CisloZnaku<=Length(VstupSlovo)) then Result:=Result+VstupSlovo[CisloZnaku]
    else PridZnak:=False;
  end;
  Result:=AnsiUpperCase(Result);
end;

function THlavni.JeVeSlovniku(VstupSlovo:string):Boolean; // zkontroluje, zda je zadane slovo ve slovniku
var SlovoSlov:string;
begin
  NactiSlovnik;
  while not EOF(SlovnikSoub) do
  begin
    ReadLn(SlovnikSoub,SlovoSlov);
    if Trim(VstupSlovo)=Trim(PrefiltrujSlovo(SlovoSlov)) then
    begin
      Result:=True;
      Exit;
    end;
  end;
  ZavriSlovnik;
end;

procedure THlavni.NactiSlovnik; //nacte soubor se slovnikem
begin
  AssignFile(SlovnikSoub,'dict.txt');
  Reset(SlovnikSoub);
end;

procedure THlavni.ZavriSlovnik; //zavre soubor se slovnikem
begin
  CloseFile(SlovnikSoub);
end;

function THlavni.OcistiSlovo(VstupSlovo:string):string; //ocisti slovo od prebytecnych znaku, jako jsou carky a tecky
var CisloZnaku:Integer;
begin
  Result:='';
  for CisloZnaku:=1 to Length(VstupSlovo) do
  begin
    if (Ord(VstupSlovo[CisloZnaku])>=48) then Result:=Result+VstupSlovo[CisloZnaku]
  end;
  Result:=AnsiUpperCase(Result);
end;

procedure THlavni.Kontroluj1Click(Sender: TObject);  //provadi kontrolu ze vstupnich udaju v graf. rozhrani a vystup pouze vypisuje do graf. rozhrani, neuklada ho
var Radek:string;
    KontPis:Integer;
    Slovo:string;
    PisVeSlov:Integer;
    NovyRadek:string;
    CisloRadky:Integer;
begin
  CisloRadky:=0;
  VystupText.Lines.Clear;
  while CisloRadky<ZdrojText.Lines.Count do
  begin
    Radek:=ZdrojText.Lines[CisloRadky];
    KontPis:=0;
    PisVeSlov:=1;
    Slovo:='';
    while KontPis<>Length(Radek)+1 do
    begin
      Inc(KontPis);
      if ((Radek[KontPis]<>' ')and(KontPis<>Length(Radek)+1)) then
      begin
        Slovo:=Slovo+' ';
        Slovo[PisVeSlov]:=Radek[KontPis];
        Inc(PisVeSlov);
      end
      else
      begin
        StatusBar1.SimpleText:='Prv kontroluji slovo: '+Slovo;
        if JeVeSlovniku(OcistiSlovo(Slovo))=True then
        begin
          NovyRadek:=NovyRadek+Slovo+' ';
        end
        else NovyRadek:=NovyRadek+'#'+Slovo+' ';
        Slovo:='';
        PisVeSlov:=1;
      end;
    end;
    VystupText.Lines.Add(NovyRadek);
    NovyRadek:='';
  Inc(CisloRadky);  
  end;
  StatusBar1.SimpleText:='Pipraven';
  Ulozeno:=False;
end;

procedure THlavni.Konec1Click(Sender: TObject); //ukonci program
begin
  Close;
end;

procedure THlavni.FormClose(Sender: TObject; var Action: TCloseAction); //graf. rozhrani: zkontroluje, zda je vysledny soubor ulozen
begin
  if not Ulozeno then if Application.MessageBox('Nemte uloen vstupn soubor!!! Mm pesto zkonit?','Varovn',MB_OKCANCEL) <> IDOK then Action:=caNone;
end;

procedure THlavni.Oaplikaci1Click(Sender: TObject); //zobrazi AboutBox
begin
  About.ShowModal;
end;

end.
